// M.Cavalleri 24/3/98
//---------------------------------------------------------------------------
#ifndef TPortH
#define TPortH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------



/*class TMyProperty : public TPropertyEditor
{
    typedef TMyProperty ThisClass;
    typedef TPropertyEditor inherited;
public:
    virtual bool __fastcall AllEqual(void);
    virtual System::AnsiString __fastcall GetValue(void);
    virtual void __fastcall SetValue(const AnsiString Value);
}; */


//---------------------------------------------------------------------------

class TPort;
typedef void __fastcall (__closure *TTriggerEvent)(DWORD trigger);
typedef void __fastcall (__closure *TPolling)(DWORD msec);


class TPort : public TComponent
{
private:
	int porta,valore;
    bool propaga,polling;
    int pollmsec;
    DWORD msec;
    TPolling FOnPolling;
    TTriggerEvent FOnTriggerEvent;

protected:
public:
	virtual int __fastcall SetBit(int bit);
  	virtual int __fastcall ResBit(int bit);
	virtual bool __fastcall GetBit(int bit);

	virtual int __fastcall QuickInput();
	virtual void __fastcall QuickOutput();
  	virtual int __fastcall Input(int pporta);
	virtual void __fastcall Output(int pporta, int vvalore);
  	virtual int __fastcall DirectInput(int pporta);
	virtual void __fastcall DirectOutput(int pporta, int vvalore);


	__fastcall TPort(TComponent* Owner);
__published:
	__property int Port  = {read=porta, write=porta};
	__property int Value = {read=valore, write=valore};
    __property bool PropagateImmediate = {read=propaga, write=propaga };
    __property bool Polling = {read=polling, write=polling };
    __property int PollingInterval  = {read=pollmsec, write=pollmsec };

	__property TPolling OnPolling = {read=FOnPolling, write=FOnPolling};
    __property TTriggerEvent OnTriggerEvent = {read=FOnTriggerEvent, write=FOnTriggerEvent};

};
//---------------------------------------------------------------------------
#endif
